AS=arm-none-eabi-as
CC=arm-none-eabi-gcc
LD=arm-none-eabi-gcc
OBJCOPY=arm-none-eabi-objcopy
HOSTCC=gcc

# use APCS for 4-bytes stack align (AAPCS is 8-bytes that is overkill for ARMv4 that doesn't have LDRD/STRD)
# note: if you are adding -mthumb, consider codes use b/bl and pop{pc} that doest not change the mode.
COMMONFLAGS=-march=armv4t -mabi=apcs-gnu -g -mthumb-interwork
ASFLAGS=$(COMMONFLAGS)
CFLAGS=$(COMMONFLAGS) -std=gnu99 -ffunction-sections -fdata-sections -fomit-frame-pointer -Wall -Wextra -Werror -Os
LDFLAGS=$(COMMONFLAGS) -nostartfiles -Wl,-T,ldscript,--gc-sections,--print-gc-sections
