#include <stdio.h>
#include <string.h>

int main(void) {
	FILE *rfp, *wfp;
	char pkicon[0x80];
	int i, index;

	// Assuming pkicon.bmp as 1bpp 32x(32*n)
	if((rfp = fopen("pkicon.bmp", "rb")) == NULL) { perror("pkicon.bmp: could not open"); }
	// convert palette
	if(fseek(rfp, 0x3E, SEEK_SET) != 0) { perror("pkicon.bmp: could not seek"); }
	for(index = 1; ; index++) {
		char fname[100];

		if(fread(pkicon, 0x80, 1, rfp) != 1) {
			break;
		}

		// converting and save image
		if(index == 1) {
			strcpy(fname, "pkicon.bin");
		} else {
			sprintf(fname, "pkicon%d.bin", index);
		}
		if((wfp = fopen(fname, "wb")) == NULL) { perror("pkicon*.bin: could not open"); }
		for(i = 0; i < 4*32; i++) {
			int j, t;
			t = 0;
			for(j = 0; j < 8; j++) {
				t |= ((pkicon[i] & (1 << j)) >> j) << (7 - j);
			}
			pkicon[i] = ~t;
		}
		for(i = 0; i < 32; i++) {
			if(fwrite(&pkicon[(31 - i) * 4], 4, 1, wfp) != 1) { perror("pkicon*.bin: could not write"); }
		}
		if(fclose(wfp) != 0) { perror("pkicon*.bin: could not close"); }
	}
	if(index == 0) {
		perror("pkicon.bmp: could not read image at all");
	}
	if(fclose(rfp) != 0) { perror("pkicon.bmp: could not close"); }

	return 0;
}
