#include <stdio.h>

int main(void) {
	FILE *fp;
	char pal[0x40], psicon[0x80];
	int i;

	// Assuming psicon.bmp as 4bpp 16x16
	if((fp = fopen("psicon.bmp", "rb")) == NULL) { perror("psicon.bmp: could not open"); }
	// convert palette
	if(fseek(fp, 0x36, SEEK_SET) != 0) { perror("psicon.bmp: could not seek"); }
	if(fread(pal, 0x40, 1, fp) != 1) { perror("psicon.bmp: could not read palette"); }
	if(fread(psicon, 0x80, 1, fp) != 1) { perror("psicon.bmp: could not read image"); }
	if(fclose(fp) != 0) { perror("psicon.bmp: could not close"); }

	// converting and save palette/image
	if((fp = fopen("psicon.bin", "wb")) == NULL) { perror("psicon.bin: could not open"); }
	// write palette
	for(i = 0; i < 16; i++) {
		short buf;
		buf = (((pal[i*4+0]>>3)&0x1F)<<10) | (((pal[i*4+1]>>3)&0x1F)<<5) | (((pal[i*4+2]>>3)&0x1F)<<0);
		if(fwrite(&buf, 2, 1, fp) != 1) { perror("psicon.pal: could not write"); }
	}
	// nibble-swap and write image
	for(i = 0; i < 0x80; i++) {
		psicon[i] = ((psicon[i] << 4) & 0xF0) | ((psicon[i] >> 4) & 0x0F);
	}
	for(i = 0; i < 16; i++) {
		if(fwrite(&psicon[(15 - i) * 8], 8, 1, fp) != 1) { perror("psicon.bin: could not write"); }
	}
	if(fclose(fp) != 0) { perror("psicon.bin: could not close"); }

	return 0;
}
