#include "common_c.h"

u32 bcd2int2(u32 bcd);
u32 int2bcd2(u32 i);

void handleRTCIRQ() {
	*I_HCLR = INTMASK_RTC;
	u8 y2 = (*RTC_DATE >> 16) & 0xFF;
	if(LastKnownYear2BCD <= y2) {
		// y2 is not wrapped; continue.
		return;
	}

	// y2 wrapped = xx99->xy00; increment century with wrap (but who use pk till 10k year!?)
	u32 c = bcd2int2(CurrentCenturyBCD);
	if(c < 99) {
		c++;
	} else {
		c = 0;
	}
	CurrentCenturyBCD = int2bcd2(c);
	LastKnownYear2BCD = y2;
}
