#include "common_S.h"

public_func main
	// setting each mode's SP, and set mode to SV at last
	mov r0, #PSR_FIQ | PSR_FIQDIS | PSR_IRQDIS; msr CPSR_cf, r0; mov sp, #0x0200
	mov r0, #PSR_IRQ | PSR_FIQDIS | PSR_IRQDIS; msr CPSR_cf, r0; mov sp, #0x0180
	mov r0, #PSR_SV  | PSR_FIQDIS | PSR_IRQDIS; msr CPSR_cf, r0; mov sp, #0x0180

	// initialize the intvector on RAM
	ldr r8, =armVectorSrc
	.reloc ., R_ARM_ABS8, armVector
	mov r9, #0
	ldmia r8!, {r0-r7}; stmia r9!, {r0-r7}
	ldmia r8!, {r0-r7}; stmia r9!, {r0-r7}

	// clearing RAM except vectors; reusing r9
	mov r8, #0
1:
	str r8, [r9], #4
	cmp r9, #0x0800
	blt 1b

	bl initDeviceRegisters

	// load initial svc vector
	ldr r0, =DefaultSvcVector
	.reloc ., R_ARM_ABS8, PtrToSvcVector
	mov r1, #0
	str r0, [r1]

	// load snapshot magic
	ldr r0, =0x45530000
	.reloc ., R_ARM_ABS8, SnapMagic
	mov r1, #0
	str r0, [r1]

	// init RTC
	mov r0, #0x19
	.reloc ., R_ARM_ABS8, CurrentCenturyBCD
	mov r1, #0
	strb r0, [r1]

	mov r0, #0x00
	.reloc ., R_ARM_ABS8, LastKnownYear2BCD
	mov r1, #0
	strb r0, [r1]

	mov r1, #0x0A000000
	// original; just store INTMASK_RTC should enough...
	//ldr r0, [r1, #0x08] // I_MASK
	//orr r0, #INTMASK_RTC
	mov r0, #INTMASK_RTC
	str r0, [r1, #0x08] // I_MASK

.globl restartGui
.type restartGui, %function
restartGui:
	// run gui as user mode with IRQ/FIQ enabled
	mov r0, #PSR_USER
	msr CPSR_cf, r0
	mov sp, #0x800

	// call gui at 04001E00 with parameter "0"
	mov r0, #0
	ldr r1, =0x04001E00
	bx r1

	.pool

	.section .lobss, "aw", %nobits
armVector: .space 4*8*2 // 0000

.balign 4
.globl KernFlags
KernFlags: .space 4 // 00C0

.balign 2
.globl BUFunc3offset
BUFunc3offset: .space 2 // 00C8
//.globl byteCA
//byteCA: .space 1 // 00CA

.globl LastKnownYear2BCD
LastKnownYear2BCD: .space 1 // 00CD
.globl AltAppIndex
AltAppIndex: .space 1 // 00CE
.globl CurrentCenturyBCD
CurrentCenturyBCD: .space 1 // 00CF

.balign 2
.globl CurrentExecAppIndex
CurrentExecAppIndex: .space 2 // 00D0
.balign 2
.globl PreparedAppIndex
PreparedAppIndex: .space 2 // 00D2
.balign 4
.globl PreparedAppParam
PreparedAppParam: .space 4 // 00D4
.balign 4
.globl AlarmSettings
AlarmSettings: .space 8 // 00D8
.balign 4
.globl PtrToSvcVector
PtrToSvcVector: .space 4 // 00E0
// E4/E8 are return struct for BUsysfunc.
.balign 4
.globl BUBuf
BUBuf: .space 8 // 00E4
// only used by sysBUFunc1(fromps)? save dst ptr to here.
.balign 4
.globl Sysbufunc1DstPtr
Sysbufunc1DstPtr: .space 4 // 00EC
.globl byteF0 // MC_LastStatus?
byteF0: .space 1 // 00F0
.globl byteF1 // MC_WaitCnt?
byteF1: .space 1 // 00F1

.balign 4
.globl CustomHandlers
CustomHandlers: .space 4*4 // 00F8; swi, irq, fiq, custom3.
.balign 4
.globl SnapMagic
SnapMagic: .space 4 // 0108

.balign 4
.globl SectBuf
SectBuf: .space 0x80 // 0040
