#include <stdio.h>
#include <string.h>

int main(int argc, char **argv) {
	char buf[0x80];
	int i;
	FILE *fp;

	if(argc < 3) {
		puts("Insufficient arguments.");
		printf("usage: %s outfile internalfilename\n", argv[0]);
		return 1;
	}

	bzero(buf, 0x80);
	buf[0] = 0x51; // first using block
	// 0x00002000 (LE) using file size = one block (0x2000 bytes)
	buf[4] = 0x00;
	buf[5] = 0x20;
	buf[6] = 0x00;
	buf[7] = 0x00;
	// 0xFFFF next block = none
	buf[8] = 0xFF;
	buf[9] = 0xFF;
	// internal file name: 20 bytes max (without null)
	strncpy(&buf[0x0A], argv[2], 20);
	// checksum
	for(i = 0; i < 0x7F; i++) {
		buf[0x7F] ^= buf[i];
	}

	if((fp = fopen(argv[1], "wb")) == NULL) { perror("could not open file"); }
	if(fwrite(buf, 0x80, 1, fp) != 1) { perror("could not write file"); }
	if(fclose(fp)) { perror("could not close file"); }

	return 0;
}
